/*******************************************************************
*
*       Simulated Maximum Likelihood estimation of the
*       stochastic volatiliy model
*       version 1.2
*       February, 1996
*
*       Jon Danielsson (c)
*       Department of Economics
*       University of Iceland
*       101 Reykjavik
*       Iceland
*       e-mail: jond@hag.hi.is
*       ftp  hag.hi.is  
*       WWW  http://www.hag.hi.is/~jond
*       
*       please cite in published work and inform the author.
*
******************************************************************/

#include <iostream.h>
#include <iomanip.h>
#include <math.h>
#include <fstream.h>
#include <stdio.h>
#include <ctype.h>
#include "common.h"
//#include <unistd.h>


#ifdef NAG_OPT
extern "C" long int  e04ccf(...);
extern "C" long int  e04hbf(...);
extern "C" void e04xaf(...);
extern "C" long int   x04caf(...);
#endif
#ifdef NRC
#endif
void Simplex(double **p, double y[], int ndim, double ftol,
       double (*funk)(double []), int *nfunk);

void free_matrix(double **m, int r1,int r2, int c1, int c2);
double **matrix(int r1, int r2, int c1, int c2);



extern int monit(double *fmin, double *fmax,double *sim,int *n,
	int *is,int *ncall);

extern int nag_func(int *n, double *x, double *xc);
//extern "C" int nag_func();

extern int objfun(int *mode, int *n, double *xbb, double *objf, double *objgrd,
int *nstate, int *iuser, double *user);


class opt {
	nag_hessian();
	nag_simplex();
	nrc_simplex();

	double *xx;
	double *bxx;

	int svec(int i);

	int sest();
	double best,delta;
	int ps;
public:
	opt(int x) ;
	~opt() ;

	int dim;
	double  *par;
	double  *se;
	double value;
	double tol;
	int iter;
	int result;
	char code[80];
	int hessian;
	int gradient;

	double (*func)(double *);
	void optimize(void);
};

int nag_simplex(opt& con);
int hessian(opt& con);
